VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cTransformer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_cores As cCoreCollection
Private m_steels As cSteelCollection
Private m_moxOrig As cINI

Private m_strName As String
Private m_core As cCore
Private m_steel As cSteel
Private m_sFreq As Single
Private m_sWatts As Single
Private m_sDCurrent As Single
Private m_sIp0 As Single
Private m_lHys As Long
Private m_sPrimaryResistance As Single
Private m_sGap As Single
Private m_fSingleEnded As Boolean
Private m_sPrimaryZ As Single
Private m_sSecondaryZ As Single
Private m_lPrimarySectNumber As Long
Private m_lSecondarySectNumber As Long
Private m_lPrimaryWiresNumber As Long
Private m_lSecondaryWiresNumber As Long
Private m_fPrimaryEquals As Boolean
Private m_fSecondaryEquals As Boolean
Private m_sPrimaryCopperD As Single
Private m_sSecondaryCopperD As Single
Private m_fCoreFixed As Boolean
Private m_lSecondaryCoilsPerSection As Long
Private m_sThickness As Single
Private m_sDielectricK As Single
Private m_sPrimaryInterlayer As Single
Private m_sSecondaryInterlayer As Single
Private m_zfPlot() As cZFreq
Private m_strRemarks As String

' For fixed mode
Private m_lPrimaryTurns As Long
Private m_lSecondaryTurns As Long

Private m_fLocked As Boolean

Private Const pi = 3.14159

Public Event ValuesChanged()

Private Sub Class_Initialize()
    Set m_core = New cCore
    Set m_steel = New cSteel
    ReDim m_zfPlot(6)
End Sub

Public Property Let Name(ByVal strName As String)
    m_strName = strName
End Property

Public Property Get Name() As String
    Name = m_strName
End Property

Public Property Set cores(ByVal coll As cCoreCollection)
    Set m_cores = coll
End Property

Public Property Set Steels(ByVal coll As cSteelCollection)
    Set m_steels = coll
End Property

Public Property Set Core(ByVal cor As cCore)
    Set m_core = cor
End Property

Public Property Get Core() As cCore
    Set Core = m_core
End Property

Public Property Set Steel(ByVal st As cSteel)
    Set m_steel = st
End Property

Public Property Get Steel() As cSteel
    Set Steel = m_steel
End Property

Public Property Let Frequency(ByVal sValue As Single)
    If m_sFreq <> sValue Then
        m_sFreq = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get Frequency() As Single
    Frequency = m_sFreq
End Property

Public Property Let Watts(ByVal sValue As Single)
    If m_sWatts <> sValue Then
        m_sWatts = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get Watts() As Single
    Watts = m_sWatts
End Property

Public Property Let DCurrent(ByVal sValue As Single)
    If m_sDCurrent <> sValue Then
        m_sDCurrent = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get DCurrent() As Single
    DCurrent = m_sDCurrent
End Property

Public Property Let Ip0(ByVal sValue As Single)
    If m_sIp0 <> sValue Then
        m_sIp0 = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get Ip0() As Single
    Ip0 = m_sIp0
End Property

Public Property Let Hys(ByVal lValue As Long)
    If m_lHys <> lValue Then
        m_lHys = lValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get Hys() As Long
    Hys = m_lHys
End Property

Public Property Let PrimaryResistance(ByVal sValue As Single)
    If m_sPrimaryResistance <> sValue Then
        m_sPrimaryResistance = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get PrimaryResistance() As Single
    PrimaryResistance = m_sPrimaryResistance
End Property

Public Property Let Gap(ByVal sValue As Single)
    If m_sGap <> sValue Then
        m_sGap = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get Gap() As Single
    Gap = m_sGap
End Property

Public Property Let SingleEnded(ByVal fValue As Boolean)
    If m_fSingleEnded <> fValue Then
        m_fSingleEnded = fValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get SingleEnded() As Boolean
    SingleEnded = m_fSingleEnded
End Property

Public Property Let Remarks(ByVal strValue As String)
    m_strRemarks = strValue
End Property

Public Property Get Remarks() As String
    Remarks = m_strRemarks
End Property

Public Property Let PrimaryZ(ByVal sValue As Single)
    If m_sPrimaryZ <> sValue Then
        m_sPrimaryZ = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get PrimaryZ() As Single
    PrimaryZ = m_sPrimaryZ
End Property

Public Property Let SecondaryZ(ByVal sValue As Single)
    If m_sSecondaryZ <> sValue Then
        m_sSecondaryZ = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get SecondaryZ() As Single
    SecondaryZ = m_sSecondaryZ
End Property

Public Property Let PrimarySectNumber(ByVal lValue As Long)
    If m_lPrimarySectNumber <> lValue Then
        m_lPrimarySectNumber = lValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get PrimarySectNumber() As Long
    PrimarySectNumber = m_lPrimarySectNumber
End Property

Public Property Let SecondarySectNumber(ByVal lValue As Long)
    If m_lSecondarySectNumber <> lValue Then
        m_lSecondarySectNumber = lValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get SecondarySectNumber() As Long
    SecondarySectNumber = m_lSecondarySectNumber
End Property

Public Property Let PrimaryWiresNumber(ByVal lValue As Long)
    If m_lPrimaryWiresNumber <> lValue Then
        m_lPrimaryWiresNumber = lValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get PrimaryWiresNumber() As Long
    PrimaryWiresNumber = m_lPrimaryWiresNumber
End Property

Public Property Let SecondaryWiresNumber(ByVal lValue As Long)
    If m_lSecondaryWiresNumber <> lValue Then
        m_lSecondaryWiresNumber = lValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get SecondaryWiresNumber() As Long
    SecondaryWiresNumber = m_lSecondaryWiresNumber
End Property

Public Property Let PrimaryEquals(ByVal fValue As Boolean)
    If m_fPrimaryEquals <> fValue Then
        m_fPrimaryEquals = fValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get PrimaryEquals() As Boolean
    PrimaryEquals = m_fPrimaryEquals
End Property

Public Property Let SecondaryEquals(ByVal fValue As Boolean)
    If m_fSecondaryEquals <> fValue Then
        m_fSecondaryEquals = fValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get SecondaryEquals() As Boolean
    SecondaryEquals = m_fSecondaryEquals
End Property

Public Property Get PrimaryCopperDiameterFixed() As Boolean
    PrimaryCopperDiameterFixed = m_sPrimaryCopperD <> 0 And Abs(m_sPrimaryCopperD - Round(Me.PrimaryCopperMinDiameter, 2)) > 0.0001
End Property

Public Property Get SecondaryCopperDiameterFixed() As Boolean
    SecondaryCopperDiameterFixed = m_sSecondaryCopperD <> 0 And Abs(m_sSecondaryCopperD - Round(Me.SecondaryCopperMinDiameter, 2)) > 0.0001
End Property

Public Property Let PrimaryCopperDiameter(ByVal sValue As Single)
    If m_sPrimaryCopperD <> sValue Then
        m_sPrimaryCopperD = sValue
        RaiseEvent ValuesChanged
    ElseIf sValue = 0 Then
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get PrimaryCopperDiameter() As Single
    If Not Me.PrimaryCopperDiameterFixed Then
        PrimaryCopperDiameter = PrimaryCopperMinDiameter
    Else
        PrimaryCopperDiameter = m_sPrimaryCopperD
    End If
End Property

Public Property Let SecondaryCopperDiameter(ByVal sValue As Single)
    If m_sSecondaryCopperD <> sValue Then
        m_sSecondaryCopperD = sValue
        RaiseEvent ValuesChanged
    ElseIf sValue = 0 Then
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get SecondaryCopperDiameter() As Single
    If Not Me.SecondaryCopperDiameterFixed Then
        SecondaryCopperDiameter = SecondaryCopperMinDiameter
    Else
        SecondaryCopperDiameter = m_sSecondaryCopperD
    End If
End Property

Public Property Let SecondaryCoilsPerSection(ByVal lValue As Long)
    If m_lSecondaryCoilsPerSection <> lValue Then
        m_lSecondaryCoilsPerSection = lValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get SecondaryCoilsPerSection() As Long
    SecondaryCoilsPerSection = m_lSecondaryCoilsPerSection
End Property

Public Property Let CoreFixed(ByVal fValue As Boolean)
    If m_fCoreFixed <> fValue Then
        m_fCoreFixed = fValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get CoreFixed() As Boolean
    CoreFixed = m_fCoreFixed
End Property

Public Property Let Thickness(ByVal sValue As Single)
    If m_sThickness <> sValue Then
        m_sThickness = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get Thickness() As Single
    If m_sThickness <> 0 Then
        Thickness = m_sThickness
    Else
        Thickness = Me.MaxIsol
    End If
End Property

Public Property Let DielectricK(ByVal sValue As Single)
    If m_sDielectricK <> sValue Then
        m_sDielectricK = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get DielectricK() As Single
    DielectricK = m_sDielectricK
End Property

Public Property Let PrimaryInterlayer(ByVal sValue As Single)
    If m_sPrimaryInterlayer <> sValue Then
        m_sPrimaryInterlayer = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get PrimaryInterlayer() As Single
    PrimaryInterlayer = m_sPrimaryInterlayer
End Property

Public Property Let SecondaryInterlayer(ByVal sValue As Single)
    If m_sSecondaryInterlayer <> sValue Then
        m_sSecondaryInterlayer = sValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get Locked() As Boolean
    Locked = m_fLocked
End Property

Public Property Let Locked(ByVal fValue As Boolean)
    If m_fLocked <> fValue Then
        If fValue Then
            m_lPrimaryTurns = Me.PrimaryTurns
            m_lSecondaryTurns = Me.SecondaryTurns
        End If
        m_fLocked = fValue
        RaiseEvent ValuesChanged
    End If
End Property

Public Property Get SecondaryInterlayer() As Single
    SecondaryInterlayer = m_sSecondaryInterlayer
End Property

Public Property Get ZFPlot() As cZFreq()
    ZFPlot = m_zfPlot
End Property

Public Property Get PrimaryCopperMinDiameter() As Single
    PrimaryCopperMinDiameter = 1.13 * Sqr((Me.PrimaryI / m_sDCurrent / m_lPrimaryWiresNumber))
End Property

Public Property Get SecondaryCopperMinDiameter() As Single
    SecondaryCopperMinDiameter = 1.13 * Sqr((Me.SecondaryI / m_sDCurrent / m_lSecondaryWiresNumber / m_lSecondaryCoilsPerSection))
End Property

Public Property Get PrimaryTurnsPerLayerMax() As Single
Dim s As Single
    
    s = Me.PrimaryCopperDiameter
    PrimaryTurnsPerLayerMax = (m_core.Lcu / (s + 0.03 + (s / 30))) - 1
End Property

Public Property Get PrimaryTurnsPerLayerActual() As Single
Dim windings As cWindingCollection
Dim wd As cWinding
Dim i As Long

    Set windings = Me.windings
    If Not windings Is Nothing Then
        If windings.Count > 0 Then
            For i = 1 To windings.Count
                Set wd = windings.Item(i)
                If wd.Usage = Primary Then
                    If PrimaryTurnsPerLayerActual < wd.Turns \ wd.Layers Then
                        PrimaryTurnsPerLayerActual = wd.Turns \ wd.Layers
                    End If
                End If
            Next
        End If
    End If
End Property

Public Property Get SecondaryTurnsPerLayerMax() As Single
Dim s As Single
    
    s = Me.SecondaryCopperDiameter
    SecondaryTurnsPerLayerMax = (m_core.Lcu / (s + 0.03 + (s / 30))) - 1
End Property

Public Property Get SecondaryTurnsPerLayerActual() As Single
Dim windings As cWindingCollection
Dim wd As cWinding
Dim i As Long
    
    Set windings = Me.windings
    If Not windings Is Nothing Then
        If windings.Count > 0 Then
            For i = 1 To windings.Count
                Set wd = windings.Item(i)
                If wd.Usage = Secondary Then
                    If SecondaryTurnsPerLayerActual < wd.Turns \ wd.Layers Then
                        SecondaryTurnsPerLayerActual = wd.Turns \ wd.Layers
                    End If
                End If
            Next
        End If
    End If
End Property

Public Property Get SPVolts() As Single
        SPVolts = 23.3 * m_lHys / m_sFreq / Me.CmIron
End Property

Public Property Get PrimaryI() As Single
    If m_sPrimaryZ Then
        PrimaryI = (m_sWatts / m_sPrimaryZ) ^ 0.5 + m_sIp0
    End If
End Property

Public Property Get SecondaryI() As Single
    If m_sSecondaryZ Then
        SecondaryI = (m_sWatts / m_sSecondaryZ) ^ 0.5
    End If
End Property

Public Property Get PrimaryV() As Single
    PrimaryV = (m_sWatts * m_sPrimaryZ) ^ 0.5
End Property

Public Property Get SecondaryV() As Single
    SecondaryV = (m_sWatts * m_sSecondaryZ) ^ 0.5
End Property

Public Property Get PrimaryTurns() As Long
    If m_fLocked Then
        PrimaryTurns = m_lPrimaryTurns
    Else
        PrimaryTurns = CLng(Me.SPVolts * Me.PrimaryV)
    End If
End Property

Public Property Get SecondaryTurns() As Long
    If m_fLocked Then
        SecondaryTurns = m_lSecondaryTurns
    Else
        SecondaryTurns = CLng(Me.SPVolts * Me.SecondaryV)
    End If
End Property

Public Property Get ZRatio() As Single
    If m_sSecondaryZ > 0 And m_sPrimaryZ > 0 Then
        ZRatio = m_sPrimaryZ / m_sSecondaryZ
    Else
        ZRatio = 1
    End If
End Property

Public Property Get CmIron() As Single
Dim s As Single

    s = 70 * Sqr(m_sWatts) / m_sFreq
    CmIron = GetCoreData(s)
End Property

Public Property Get Capacity() As Single
    Capacity = 0.088 * m_core.Lcu * m_core.AverageTurnLength / Me.Thickness * m_sDielectricK / 1000
End Property

Public Property Get Req() As Single
    If m_sPrimaryResistance <> 0 Then
        Req = m_sPrimaryResistance * m_sPrimaryZ / (m_sPrimaryResistance + m_sPrimaryZ)
    Else
        Req = m_sPrimaryZ
    End If
End Property

Public Property Get FreqMin() As Single
    FreqMin = Me.Req / (2 * pi * Me.PrimaryInductance)
End Property

Public Property Get PrimaryInductance() As Single
    PrimaryInductance = Me.Perm * Me.PrimaryTurns ^ 2 * m_core.IronSection * 10 ^ -8 / m_core.IronLength
End Property

Public Property Get NumberOfIsolations() As Long
    NumberOfIsolations = m_lPrimarySectNumber * m_lPrimaryWiresNumber + m_lSecondarySectNumber * m_lSecondaryWiresNumber
    NumberOfIsolations = NumberOfIsolations - 1
    If m_fPrimaryEquals Or m_fSecondaryEquals Then
        NumberOfIsolations = NumberOfIsolations + 1
    End If
End Property

Public Property Get PrimaryTurnsPerSection() As Single
    PrimaryTurnsPerSection = Me.PrimaryTurns / m_lPrimarySectNumber
End Property

Public Property Get SecondaryTurnsPerSection() As Single
    SecondaryTurnsPerSection = Me.SecondaryTurns / m_lSecondarySectNumber
End Property

Public Property Get PrimaryLayers() As Single
    PrimaryLayers = Me.PrimaryTurnsPerSection \ Me.PrimaryTurnsPerLayerMax
    If PrimaryLayers < Me.PrimaryTurnsPerSection / Me.PrimaryTurnsPerLayerMax Then
        PrimaryLayers = PrimaryLayers + 1
    End If
End Property

Public Property Get SecondaryLayers() As Single
    SecondaryLayers = Me.SecondaryTurnsPerSection \ Me.SecondaryTurnsPerLayerMax
    If SecondaryLayers < Me.SecondaryTurnsPerSection / Me.SecondaryTurnsPerLayerMax Then
        SecondaryLayers = SecondaryLayers + 1
    End If
End Property

Public Property Get AC() As Single
    AC = Me.PrimaryV * 10 ^ 4 / (4.44 * Me.PrimaryTurns * m_core.IronSection * m_sFreq)  '/ 10000   'en Tesla
End Property

Public Property Get DC() As Single
Dim sGap As Single
Dim sAC As Single
Dim sMU As Single
    
    If m_fSingleEnded Then
        sGap = m_sGap / 10  'Displayed in mm, convert in cm
        sAC = Me.PrimaryV * 10 ^ 4 / (4.44 * Me.PrimaryTurns * m_core.IronSection * m_sFreq)  '/ 10000   'en Tesla
        sMU = m_steel.Extrapol(sAC)
        sMU = sMU / (1 + (sMU * (sGap / m_core.IronLength)))
        DC = sMU * m_sIp0 * Me.PrimaryTurns / m_core.IronLength / 10000      'en Tesla
    Else
        DC = 0
    End If
End Property

Public Property Get TrueTesla() As Single
    TrueTesla = Me.AC + Me.DC
End Property

Public Property Get TrueFeLoss() As Single
    TrueFeLoss = 0.6 * m_core.IronMass * (Me.TrueTesla ^ 2) * (m_sFreq / 50)
End Property

'Retourne permabilit selon B et GAP
Public Property Get Perm() As Single
Dim sGap As Single
Dim sAC As Single
Dim sDC As Single
Dim sMU As Single

    sGap = m_sGap / 10  'Displayed in mm, convert in cm
    sAC = Me.PrimaryV * 10 ^ 4 / (4.44 * Me.PrimaryTurns * m_core.IronSection * m_sFreq)  '/ 10000   'en Tesla
    sMU = m_steel.Extrapol(sAC)
    sMU = sMU / (1 + (sMU * (sGap / m_core.IronLength)))
    
    If m_fSingleEnded Then
        sDC = sMU * m_sIp0 * Me.PrimaryTurns / m_core.IronLength / 10000
        sMU = m_steel.Extrapol(sAC + sDC)
        sMU = sMU / (1 + (sMU * (sGap / m_core.IronLength)))
    End If
    
    Perm = sMU
End Property

Public Property Get PrimaryTotalCu() As Single
Dim cd As Single

    cd = Me.PrimaryCopperDiameter
    If cd <> 0 Then
        ' Added 0.3mm isol each layer ''
        PrimaryTotalCu = Me.PrimaryWiresNumber * Me.PrimarySectNumber * (cd + 0.03 + Me.PrimaryInterlayer + (cd / 30)) * Me.PrimaryLayers  'This is copper height
    Else
        PrimaryTotalCu = 0
    End If
End Property

Public Property Get SecondaryTotalCu() As Single
Dim cd As Single

    cd = Me.SecondaryCopperDiameter
    If cd <> 0 Then
        SecondaryTotalCu = Me.SecondaryWiresNumber * Me.SecondarySectNumber * (cd + 0.03 + Me.SecondaryInterlayer + (cd / 30)) * Me.SecondaryLayers     'This is copper height
        SecondaryTotalCu = SecondaryTotalCu * Me.SecondaryCoilsPerSection
    Else
        SecondaryTotalCu = 0
    End If
        
End Property

Public Property Get TotalCu() As Single
    'Ajoute carton protection 0.2 mm
    TotalCu = Me.PrimaryTotalCu + Me.SecondaryTotalCu + 0.2
End Property

Public Property Get MaxIsol() As Single
    MaxIsol = (m_core.Hcu - Me.TotalCu) / Me.NumberOfIsolations
End Property

Public Property Get N2() As Single
    If m_fPrimaryEquals Or m_fSecondaryEquals Then  '   Split winding button
        N2 = Me.NumberOfIsolations ^ 2
    Else
        N2 = ((m_lPrimarySectNumber * m_lPrimaryWiresNumber + m_lSecondarySectNumber * m_lSecondaryWiresNumber) / 2) ^ 2
    End If
End Property

Public Property Get LeakL() As Single
'Dim sLL0 As Single   ' Valeur avant sandwich
'Dim sP1 As Single
'Dim sP2 As Single
'Dim sP3 As Single
Dim sTotalCu As Single
Dim sN2 As Single
Dim sThickness As Single
Dim sLL1 As Single
Dim sPrimaryTurns As Single
    
    sN2 = Me.N2
    If sN2 = 0 Then
        Exit Property
    End If
    
    sThickness = m_sThickness
    If sThickness = 0 Then sThickness = Me.MaxIsol
    
    sTotalCu = Me.PrimaryTotalCu + Me.SecondaryTotalCu
    sPrimaryTurns = Me.PrimaryTurns

'''''''''''''''''''''' From P.Turner ...

'    LeakL = (0.417 * sPrimaryTurns * sPrimaryTurns * Me.Core.AverageTurnLength * (2 * Me.NumberOfIsolations * Me.Thickness + (sTotalCu + (Me.NumberOfIsolations * Me.Thickness)))) / Me.NumberOfIsolations / Me.NumberOfIsolations / Me.Core.Lcu
'    LeakL = (TbTurns(0) * TbTurns(0) * LSpMoy * (2 * Me.NumberOfIsolations * Me.Thickness + (STot + (Me.NumberOfIsolations * Me.Thickness)))) / Me.NumberOfIsolations / Me.NumberOfIsolations / Me.Core.Lcu
'    Debug.Print "PT: " & LeakL / 10000

'''''''''''''''''''''' From Puechmorel ...

'    sP1 = LSpMoy * Val(TxTotCu(0).Text) ' / 3  'Section du primaire
'    sP2 = LSpMoy * Val(TxTotCu(1).Text) ' / 3  'Section du secondaire
'    sP3 = LSpMoy * Me.Thickness * Me.NumberOfIsolations ' / 3 'Section de l'isolement
'    sP1 = Me.PrimaryTotalCu / 3
'    sP2 = Me.SecondaryTotalCu / 3
'    sLL0 = sPrimaryTurns * sPrimaryTurns * (sP1 + sP2 + sThickness) * Me.Core.AverageTurnLength / Me.Core.Lcu
'    LeakL = sLL0 / sN2   'Me.NumberOfIsolations / Me.NumberOfIsolations ' * sK
'    Debug.Print "PM: " & LeakL / 10000
'    LbLL.Caption = Format(LeakL / 10000, "##.0 mH")

''''''''''''''''''''' From Plovati

'    LeakL = 10.6 * TbTurns(0) * TbTurns(0) * LSpMoy * (2 * Me.NumberOfIsolations * sThickness + sTotalCu) / sN2 / 7277
    LeakL = sPrimaryTurns * sPrimaryTurns * m_core.AverageTurnLength * (2 * Me.NumberOfIsolations * sThickness + sTotalCu) / sN2 / 686

' Y.M. No reference to Lcu in this formula ! ?

'    Debug.Print "PL: " & LeakL / 10000

''''''''''''''''''''' From N.H.Crowurst ...

    sThickness = sThickness + (sTotalCu / 3 / sN2)
    sLL1 = sThickness * m_core.AverageTurnLength / m_core.Lcu * sPrimaryTurns * sPrimaryTurns / 24
'    LbLL.Caption = Format(LeakL / 10000, "##.0 mH")
'    Debug.Print "NHC: " & sLL1 / 10000

' Y.M. The results for LL are good for large OPT (e.g. EI126_50) but optimistic (about twice too low) for an EI66-34.
' The size is indirecty related to Lcu and LSpMoy.

End Property

Public Property Get FreqMax() As Single
Dim sK As Single

    sK = m_sPrimaryResistance
    If sK = 0 Then sK = 10 ^ 6
    FreqMax = (sK + m_sPrimaryZ) / (1.7 * pi * Me.LeakL / 10000)
End Property

Public Property Get FreqRes() As Single
'''''''''''''''''''''''From P.Turner ...
    FreqRes = 5.035 / (Sqr((Me.LeakL / 10000) * (Me.Capacity / 1000)))
End Property

Public Property Get Q() As Single
Dim sFreqMax As Single

    sFreqMax = Me.FreqMax
    If sFreqMax > 0 Then
        Q = sFreqMax / Me.FreqRes
    Else
        Q = 0
    End If
End Property

Public Property Get PrimaryCopperLength() As Single
    PrimaryCopperLength = m_core.AverageTurnLength * Me.PrimaryTurns
End Property

Public Property Get SecondaryCopperLength() As Single
    SecondaryCopperLength = m_core.AverageTurnLength * Me.SecondaryTurns
End Property

Public Property Get PrimaryCopperResistance() As Single
Dim L As Single
Dim cd As Single

    L = Me.PrimaryCopperLength
    cd = Me.PrimaryCopperDiameter
    If L > 0 And cd > 0 Then
        PrimaryCopperResistance = (1.86 * L) / (10000 * (3.14 * (cd / 2) ^ 2))
        PrimaryCopperResistance = PrimaryCopperResistance / m_lPrimaryWiresNumber
    End If
End Property

Public Property Get SecondaryCopperResistance() As Single
Dim L As Single
Dim cd As Single

    L = Me.SecondaryCopperLength
    cd = Me.SecondaryCopperDiameter
    If L > 0 And cd > 0 Then
        SecondaryCopperResistance = (1.86 * L) / (10000 * (3.14 * (cd / 2) ^ 2))
        SecondaryCopperResistance = SecondaryCopperResistance / m_lSecondaryWiresNumber
        SecondaryCopperResistance = SecondaryCopperResistance / m_lSecondaryCoilsPerSection
    End If
End Property

Public Property Get CuW() As Single
    CuW = Me.PrimaryCopperResistance * (Me.PrimaryI ^ 2) + Me.SecondaryCopperResistance * (Me.SecondaryI ^ 2)
End Property

Public Property Get CuWAc() As Single
    CuWAc = Me.PrimaryCopperResistance * ((Me.PrimaryI - Me.Ip0) ^ 2) + Me.SecondaryCopperResistance * (Me.SecondaryI ^ 2)
End Property

'Return the sandwich, if NHC is true, both first and last sections are half the size
Public Property Get windings() As cWindingCollection
Dim lPriSects As Long
Dim lSecSects As Long
Dim lTotalSects As Long
Dim lCurrent As Long      'If 0: primary, 1: secondary
Dim sIlThick(1) As Single
Dim lTurns(1) As Long
Dim lTurnsMax(1) As Long
Dim lSectPerLayers(1) As Long
Dim lCurrentTurns As Long
Dim lNLayers As Long
Dim wd As cWinding
Dim wd0 As cWinding
Dim i As Long
Dim lCount As Long

    Set windings = Nothing
    
    lPriSects = m_lPrimarySectNumber * m_lPrimaryWiresNumber
    lSecSects = m_lSecondarySectNumber * m_lSecondaryWiresNumber
'    If lPriSects <> lSecSects Then
'        Exit Property
    If Abs(lPriSects - lSecSects) > 1 Then
        Exit Property
    End If
    
    lTotalSects = lPriSects + lSecSects
    If Me.PrimaryEquals Then lCurrent = 0 ' Primary
    If Me.SecondaryEquals Then lCurrent = 1 ' Secondary
    If lSecSects > lPriSects Then lCurrent = 1 ' Secondary
    If lPriSects > lSecSects Then lCurrent = 0 ' Primary
    
    lTurns(0) = Me.PrimaryTurnsPerSection
    lTurns(1) = Me.SecondaryTurnsPerSection
    lTurnsMax(0) = Me.PrimaryTurnsPerLayerMax
    lTurnsMax(1) = Me.SecondaryTurnsPerLayerMax
    sIlThick(0) = Me.PrimaryInterlayer
    sIlThick(1) = Me.SecondaryInterlayer
    lCurrentTurns = lTurns(lCurrent)
    
    lNLayers = lCurrentTurns \ lTurnsMax(lCurrent)
    If lNLayers < lCurrentTurns / lTurnsMax(lCurrent) Then
        lNLayers = lNLayers + 1
    End If
    
    Set windings = New cWindingCollection
    
    If Me.PrimaryEquals Or Me.SecondaryEquals Then  '   Split winding button
        lCount = lTotalSects
        lCurrentTurns = lCurrentTurns \ 2
        lNLayers = lCurrentTurns \ lTurnsMax(lCurrent)
        If lNLayers < lCurrentTurns / lTurnsMax(lCurrent) Then
            lNLayers = lNLayers + 1
        End If
        Set wd0 = New cWinding
        With wd0
            .Name = "wd0"
            .Usage = lCurrent
            .Layers = lNLayers
            .Turns = lCurrentTurns
            .Cap = 1.11 * Me.Core.Lcu * Me.Core.AverageTurnLength / (0.05 + sIlThick(lCurrent)) * 0.3 * (lNLayers - 1) / lNLayers / lNLayers
            .L = Me.Perm * lCurrentTurns ^ 2 * Me.Core.IronSection * 10 ^ -8 / Me.Core.IronLength * 1000
            .PercentWidth = 50
        End With
        Call windings.Add(wd0)
    Else    '   Not splited
        lCount = lTotalSects - 1
        lNLayers = lCurrentTurns \ lTurnsMax(lCurrent)
        If lNLayers < lCurrentTurns / lTurnsMax(lCurrent) Then
            lNLayers = lNLayers + 1
        End If
        Set wd0 = New cWinding
        With wd0
            .Name = "wd0"
            .Usage = lCurrent
            .Layers = lNLayers
            .Turns = lCurrentTurns
            .Cap = 1.11 * Me.Core.Lcu * Me.Core.AverageTurnLength / (0.05 + sIlThick(lCurrent)) * 0.3 * (lNLayers - 1) / lNLayers / lNLayers
            .L = Me.Perm * lCurrentTurns ^ 2 * Me.Core.IronSection * 10 ^ -8 / Me.Core.IronLength * 1000
            .PercentWidth = 100
        End With
        Call windings.Add(wd0)
    End If
    
    ' Set intermediate windings
    For i = 1 To lCount
        If lCurrent = 1 Then
            lCurrent = 0
        Else
            lCurrent = 1
        End If
        lCurrentTurns = lTurns(lCurrent)
        lNLayers = lTurns(lCurrent) \ lTurnsMax(lCurrent)
        If lNLayers < lTurns(lCurrent) / lTurnsMax(lCurrent) Then
            lNLayers = lNLayers + 1
        End If
        Set wd = New cWinding
        With wd
            .Name = "wd" & CStr(i)
            .Usage = lCurrent
            .Layers = lNLayers
            .Turns = lCurrentTurns
            .Cap = 1.11 * Me.Core.Lcu * Me.Core.AverageTurnLength / (0.05 + sIlThick(lCurrent)) * 0.3 * (lNLayers - 1) / lNLayers / lNLayers
            .L = Me.Perm * lCurrentTurns ^ 2 * Me.Core.IronSection * 10 ^ -8 / Me.Core.IronLength * 1000
            .PercentWidth = 100
        End With
        Call windings.Add(wd)
    Next i
    
    i = i - 1
    If Me.PrimaryEquals Or Me.SecondaryEquals Then   '   Make Last same as First
        Set wd = windings.Item(i + 1)
        With wd
            .Usage = wd0.Usage
            .Layers = wd0.Layers
            .Turns = wd0.Turns
            .Cap = wd0.Cap
            .L = wd0.L
            .PercentWidth = wd0.PercentWidth
        End With
    End If
    
End Property

Public Property Get HasChanged() As Boolean
    If m_moxOrig Is Nothing Then
        HasChanged = True
    Else
        HasChanged = Not m_moxOrig.Compare(Me.Mox)
    End If
End Property

Private Function GetCoreData(ByVal sMin As Single) As Single
'Retourne section rlle du noyau trouv
Dim cor As cCore
Dim i As Integer

    If m_cores.Count > 0 And m_fCoreFixed = False Then
        'Trie selon le poids du fer
        Call m_cores.Sort(enumSortOrders.Ascending, enumCoreFields.IronMass)
        For i = 1 To m_cores.Count
            Set cor = m_cores.Item(i)
            If cor.IronSection >= sMin Then
                Exit For
            End If
        Next i
        
        Set m_core = cor
    End If

    GetCoreData = m_core.IronSection
                
End Function

' Get a new mx class with the current parameters
Public Property Get Mox() As cINI
Dim mx As New cINI
Dim i As Long
Dim lIndex As Long
Dim strValue As String
Dim mub As cMuB
Dim strSep As String

    On Error GoTo ErrorFlag

    strSep = DecimalSpecifier

    Call mx.WriteSingle("SPECIFS", "Freq", m_sFreq)
    Call mx.WriteSingle("SPECIFS", "Watts", m_sWatts)
    Call mx.WriteSingle("SPECIFS", "DCourant", m_sDCurrent)
    Call mx.WriteSingle("SPECIFS", "Ip0", m_sIp0)
    Call mx.WriteLong("SPECIFS", "Hys", m_lHys)
    Call mx.WriteSingle("SPECIFS", "Rp", m_sPrimaryResistance)
    Call mx.WriteSingle("SPECIFS", "Gap", m_sGap)
    Call mx.WriteLong("SPECIFS", "SE", IIf(m_fSingleEnded, 1, 0))
    
    Call mx.WriteStringMultiLines("REMARQUES", "FreeText", m_strRemarks)

    Call mx.WriteSingle("SPECIFS", "Z0", m_sPrimaryZ)
    Call mx.WriteSingle("SPECIFS", "Z1", m_sSecondaryZ)
    Call mx.WriteLong("SPECIFS", "Fract0", m_lPrimarySectNumber)
    Call mx.WriteLong("SPECIFS", "Fract1", m_lSecondarySectNumber)
    Call mx.WriteLong("SPECIFS", "Fils0", m_lPrimaryWiresNumber)
    Call mx.WriteLong("SPECIFS", "Fils1", m_lSecondaryWiresNumber)
    Call mx.WriteLong("SPECIFS", "IL0", IIf(m_fPrimaryEquals, 1, 0))
    Call mx.WriteLong("SPECIFS", "IL1", IIf(m_fSecondaryEquals, 1, 0))
        
    If Me.PrimaryCopperDiameterFixed Then
        Call mx.WriteSingle("CUIVRE", "Dia0", m_sPrimaryCopperD)
    End If
    
    If Me.SecondaryCopperDiameterFixed Then
        Call mx.WriteSingle("CUIVRE", "Dia1", m_sSecondaryCopperD)
    End If
    
    Call mx.WriteLong("SPECIFS", "FilsSecondaire", m_lSecondaryCoilsPerSection)
        
    Call mx.WriteString("NOYAU", "Type", IIf(m_fCoreFixed, m_core.Name, ""))
    
    ' Stockage de caractrisitques du noyeau au cas ou il est supprim de la liste
    Call mx.WriteString("NOYAU", "CoreValues", Replace$(Format$(m_core.IronSection), strSep, ".") & "," & _
        Replace$(Format$(m_core.IronMass), strSep, ".") & "," & _
        Replace$(Format$(m_core.IronLength), strSep, ".") & "," & _
        Replace$(Format$(m_core.Hcu), strSep, ".") & "," & _
        Replace$(Format$(m_core.Lcu), strSep, ".") & "," & _
        Replace$(Format$(m_core.AverageTurnLength), strSep, "."))

    Call mx.WriteString("NOYAU", "Steel", m_steel.Name)

    ' Stockage de caractrisitques du steel au cas ou il est supprim de la liste
    strValue = m_steel.Tmax
    For Each mub In m_steel.MuBs
        strValue = strValue & "," & _
            Replace$(Format$(mub.B), strSep, ".") & "," & _
            Replace$(Format$(mub.Mu), strSep, ".")
    Next
    Call mx.WriteString("NOYAU", "SteelValues", strValue)

    Call mx.WriteSingle("ISOL", "Thickness", m_sThickness)
    Call mx.WriteSingle("ISOL", "DielectricK", m_sDielectricK)
    Call mx.WriteSingle("ISOL", "PrimaryInterlayer", m_sPrimaryInterlayer)
    Call mx.WriteSingle("ISOL", "SecondaryInterlayer", m_sSecondaryInterlayer)

    lIndex = 0
    For i = 0 To 6
        If Not m_zfPlot(i) Is Nothing Then
            Call mx.WriteString("ZFPLOT", Format$(lIndex), Replace$(Format$(m_zfPlot(i).Frequency), strSep, ".") & ":" & Format$(m_zfPlot(i).Z))
            lIndex = lIndex + 1
        End If
    Next i

    Set Mox = mx
    
    Exit Property
ErrorFlag:
    Select Case MsgBox(Err.Description, vbCritical + vbAbortRetryIgnore, App.Title)
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
End Property

Public Property Set Mox(ByVal mx As cINI)
Dim strValue As String
Dim strValues() As String
Dim strKeys() As String
Dim lPos As Long
Dim i As Long
Dim lIndex As Long
Dim lStart As Long
Dim lEnd As Long
Dim sValue As Single
Dim lValue As Long
Dim strParameters As String
Dim strParameter() As String
Dim mub As cMuB
Dim strSep As String

    On Error GoTo ErrorFlag

    strSep = DecimalSpecifier
    
    m_sFreq = mx.ReadSingle("SPECIFS", "Freq")
    m_sWatts = mx.ReadSingle("SPECIFS", "Watts")
    m_sDCurrent = mx.ReadSingle("SPECIFS", "DCourant")
    m_sIp0 = mx.ReadSingle("SPECIFS", "Ip0")
    
    lValue = mx.ReadLong("SPECIFS", "Hys", 0)
    If lValue > 0 Then
        m_lHys = lValue
    End If
        
    m_sPrimaryResistance = mx.ReadSingle("SPECIFS", "Rp")
    m_sGap = mx.ReadSingle("SPECIFS", "Gap")
    m_fSingleEnded = mx.ReadSingle("SPECIFS", "SE") <> 0

    m_strRemarks = mx.ReadStringMultiLines("REMARQUES", "FreeText")

    m_sPrimaryZ = mx.ReadSingle("SPECIFS", "Z0")
    m_sSecondaryZ = mx.ReadSingle("SPECIFS", "Z1")
    m_lPrimarySectNumber = mx.ReadSingle("SPECIFS", "Fract0")
    m_lSecondarySectNumber = mx.ReadLong("SPECIFS", "Fract1", 0)
     
    lValue = mx.ReadLong("SPECIFS", "Fils0", 0)
    m_lPrimaryWiresNumber = IIf(lValue > 1, lValue, 1)
    
    lValue = mx.ReadLong("SPECIFS", "Fils1", 0)
    m_lSecondaryWiresNumber = IIf(lValue > 1, lValue, 1)
    
    m_fPrimaryEquals = mx.ReadLong("SPECIFS", "IL0", 0) <> 0
    m_fSecondaryEquals = mx.ReadLong("SPECIFS", "IL1", 0) <> 0

    sValue = mx.ReadSingle("CUIVRE", "Dia0")
    If sValue > 0 Then
        m_sPrimaryCopperD = sValue
    Else
        m_sPrimaryCopperD = 0
    End If
    
    sValue = mx.ReadSingle("CUIVRE", "Dia1")
    If sValue > 0 Then
        m_sSecondaryCopperD = sValue
    Else
        m_sSecondaryCopperD = 0
    End If

    lValue = mx.ReadLong("SPECIFS", "FilsSecondaire", 0)
    m_lSecondaryCoilsPerSection = IIf(lValue > 0, lValue, 1)

    strValue = mx.ReadString("NOYAU", "Type")
    If Len(strValue) > 0 Then
        m_fCoreFixed = True
        Set m_core = m_cores.GetCoreByName(strValue)
    Else
        m_fCoreFixed = False
    End If
    
    If m_core Is Nothing Then
        ' Rcupration des valeurs du noyeau dans le mox
        strParameters = mx.ReadString("NOYAU", "CoreValues")
        If Len(strParameters) > 0 Then
            strParameter = Split(strParameters, ",")
            If UBound(strParameter) = 5 Then
                Set m_core = New cCore
                m_core.Name = strValue
                m_core.IronSection = CSng(Replace$(strParameter(0), ".", strSep))
                m_core.IronMass = CSng(Replace$(strParameter(1), ".", strSep))
                m_core.IronLength = CSng(Replace$(strParameter(2), ".", strSep))
                m_core.Hcu = CSng(Replace$(strParameter(3), ".", strSep))
                m_core.Lcu = CSng(Replace$(strParameter(4), ".", strSep))
                m_core.AverageTurnLength = CSng(Replace$(strParameter(5), ".", strSep))
                Call m_cores.Add(m_core)
            End If
        End If
    End If
    
    If m_core Is Nothing Then
        ' Toujours pas de noyeau !!!!
        If m_cores.Count > 0 Then
            Set m_core = m_cores.Item(1)
        Else
            Set m_core = New cCore
            m_core.Name = "Core"
            Call m_cores.Add(m_core)
        End If
    End If

    strValue = mx.ReadString("NOYAU", "Steel")
    If Len(strValue) > 0 Then
        Set m_steel = m_steels.GetSteelByName(strValue)
    End If

    If m_steel Is Nothing Then
        ' Rcupration des valeurs du steel dans le mox
        strParameters = mx.ReadString("NOYAU", "SteelValues")
        If Len(strParameters) > 0 Then
            strParameter = Split(strParameters, ",")
            If UBound(strParameter) \ 2 = UBound(strParameter) / 2 And UBound(strParameter) >= 2 Then
                Set m_steel = New cSteel
                m_steel.Name = strValue
                m_steel.Tmax = CSng(Replace$(strParameter(0), ".", strSep))
                For i = 1 To UBound(strParameter) Step 2
                    Set mub = New cMuB
                    mub.B = CSng(Replace$(strParameter(i), ".", strSep))
                    mub.Mu = CSng(Replace$(strParameter(i + 1), ".", strSep))
                    Call m_steel.MuBs.Add(mub)
                Next
                Call m_steels.Add(m_steel)
            End If
        End If
    End If
    
    If m_steel Is Nothing Then
        ' Toujours pas de steel !!!!
        If m_steels.Count > 0 Then
            Set m_steel = m_steels.Item(1)
        Else
            Set m_steel = New cSteel
            m_steel.Name = "Steel"
            Call m_steels.Add(m_steel)
        End If
    End If
    
    m_sThickness = mx.ReadSingle("ISOL", "Thickness")
    sValue = mx.ReadSingle("ISOL", "DielectricK")
    m_sDielectricK = IIf(sValue > 0, sValue, 5)
    
    m_sPrimaryInterlayer = mx.ReadSingle("ISOL", "PrimaryInterlayer")
    m_sSecondaryInterlayer = mx.ReadSingle("ISOL", "SecondaryInterlayer")

    strKeys = mx.GetKeysInSection("ZFPLOT")
    For i = 0 To UBound(strKeys)
        If Len(strKeys(i)) > 0 Then
            strValue = mx.ReadString("ZFPLOT", CStr(i))
            lPos = InStr(strValue, ":")
            If lPos > 0 Then
                Set m_zfPlot(lIndex) = New cZFreq
                m_zfPlot(lIndex).Frequency = CSng(Replace$(Left$(strValue, lPos - 1), ".", strSep))
                m_zfPlot(lIndex).Z = CSng(Replace$(Right$(strValue, Len(strValue) - lPos), ".", strSep))
                lIndex = lIndex + 1
                If lIndex > UBound(m_zfPlot) Then
                    Exit For
                End If
            End If
        End If
    Next
    
    ' Extract name
    lStart = InStrRev(mx.File, "\")
    lEnd = InStrRev(mx.File, ".") - 1
    
    If lStart <= 0 Then
        lStart = 1
    End If
    
    If lEnd <= 0 Then
        lEnd = Len(mx.File)
    End If
    
    m_strName = Mid$(mx.File, lStart, lEnd)
    Set m_moxOrig = mx
    
    RaiseEvent ValuesChanged
    
    Exit Property
ErrorFlag:
    Select Case MsgBox(Err.Description, vbCritical + vbAbortRetryIgnore, App.Title)
        Case vbRetry
            Resume
        Case vbIgnore
            Resume Next
    End Select
End Property

